"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _RQElementContainer = _interopRequireDefault(require("../../../renderer/RQElementContainer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var container;

try {
  container = new _RQElementContainer.default(__mainWindow, {
    defaultProp: 'data'
  });
} catch (error) {
  console.error('__mainWindow not found');
}

var omit = function omit(props) {
  return function (source) {
    return Object.keys(source).reduce(function (target, key) {
      if (props.indexOf(key) === -1) {
        target[key] = source[key];
      }

      return target;
    }, {});
  };
};

var omitNonNativeProps = omit(['children', 'ref', 'forwardedRef', 'key']);

var MainWindowWrapper =
/*#__PURE__*/
function (_React$Component) {
  _inherits(MainWindowWrapper, _React$Component);

  function MainWindowWrapper() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, MainWindowWrapper);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(MainWindowWrapper)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "onClosing", function (ev) {
      ev.accepted = false;

      if (_this.props.onClosing) {
        _this.props.onClosing(ev);
      }
    });

    return _this;
  }

  _createClass(MainWindowWrapper, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          visible = _this$props.visible,
          visibility = _this$props.visibility,
          forwardedRef = _this$props.forwardedRef,
          children = _this$props.children,
          otherProps = _objectWithoutProperties(_this$props, ["visible", "visibility", "forwardedRef", "children"]);

      try {
        forwardedRef.current = __mainWindow;
      } catch (e) {
        // no mainwindow
        console.error('__mainWindow not found');
      }

      var defaultVisibility = visible ? 'AutomaticVisibility' : 'Hidden';

      var nextProps = _objectSpread({
        // onClosing: this.onClosing,
        visible: visible,
        visibility: visibility ? visibility : defaultVisibility
      }, otherProps);

      container.updateNativeProps({}, nextProps);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var forwardedRef = this.props.forwardedRef;

      try {
        forwardedRef.current = __mainWindow;
      } catch (e) {
        // no mainwindow
        console.error('__mainWindow not found');
      }

      container.updateNativeProps(omitNonNativeProps(prevProps), omitNonNativeProps(this.props));
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var forwardedRef = this.props.forwardedRef;

      if (forwardedRef) {
        forwardedRef.current = null;
      } // reset props


      container.updateNativeProps(omitNonNativeProps(this.props), {});
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_react.default.Fragment, null, this.props.children);
    }
  }]);

  return MainWindowWrapper;
}(_react.default.Component);

var MainWindow = _react.default.forwardRef(function (props, ref) {
  return _react.default.createElement(MainWindowWrapper, _extends({
    forwardedRef: ref
  }, props));
});

var _default = MainWindow;
exports.default = _default;